#include <stdio.h>

#define N 100

/**
 * affiche les n premiers elements du tableau
 */
void affiche(int tab[], int n){
	int i;
	for(i=0; i<n; i++)
		printf("%d ", tab[i]);
	printf("\n");
}

/**
 * Fusion de 2 tableaux fonctionne par effet de bord
 * nA est le nombre d'elements dans A
 * nB est le nombre d'elements dans B
 */
 void fusion(int A[], int nA, int B[], int nB, int C[]){
 	int iA=0, iB=0, k;
 	for(k=0; k<nA+nB; k++){
 		if((iA!=nA && A[iA]<=B[iB]) || iB == nB){
 			C[k] = A[iA];
 			iA ++;
 		}else{
 			C[k] = B[iB];
 			iB ++;
 		}
 	}
 }
 
 int main(){
 	int nA, nB;
 	int A[]={3, 6, 9, 22};
 	int B[]={1, 2, 7, 8, 9, 24};
 	int C[N];
 	nA = 4;
 	nB = 6;
 	
 	printf("A = ");
 	affiche(A, nA);
 	
 	printf("B = ");
 	affiche(B, nB);
 	
 	fusion(A, nA, B, nB, C);
 	printf("premiere fusion : ");
 	affiche(C, nA+nB);
 	
 	fusion(B, nB, A, nA, C);
 	printf("seconde fusion : ");
 	affiche(C, nA+nB);

	return 0; 	
 }