#include <stdio.h>

#define N 20


void affiche_triangle(int n, int triangle[][N]){
	int i, j;
	for(i = 0; i<= n; i++){
		for(j=0; j<=i; j++)
			printf("%5d ", triangle[i][j]);
		printf("\n");
	}
}

void pascal(int n, int triangle[][N]){
	int i,j;
	for(i = 0; i<= n; i++)
		for(j=0; j<=i; j++)
			if(j==0 || j==i)
				triangle[i][j] = 1;
			else
				triangle[i][j] = triangle[i-1][j-1] + triangle[i-1][j];
}

int main(){
	int n, triangle[N][N];
	
	do{
		printf("Entrer une valeur de n entre 0 et %d pour le triangle de Pascal : ", N-1);
		scanf("%d", &n);
	}while (n>=N || n<0);
	
	pascal(n, triangle);
	affiche_triangle(n, triangle);

	return 0;
}