#include <stdio.h>

#define N 100

/**
 * affiche les n premiers elements du tableau
 */
void affiche(int tab[], int n){
	int i;
	for(i=0; i<n; i++)
		printf("%d ", tab[i]);
	printf("\n");
}

/** 
 * tassage fonctionne par effet de bord.
 * tasse les n premieres valeurs de tab.
 */
void tassage(int tab[], int n){
	int i, j=0;

	for(i=0; i<n; i++){
		if(tab[i] != 0){
			tab[j] = tab[i];
			j ++;
		}
	}
	for(; j<n; j++)
		tab[j] = 0;
}

int main(){
	
	int tab[N]={0, 0, 1, 4, 0, 3, 0, 0, 7, 0, 0};
	
	printf("Tableau avant tassage : \n");
	affiche(tab, 11);
	
	tassage(tab, 11);
	printf("Tableau apres tassage : \n");
	affiche(tab, 11);
	
	return 0;
}