#include <stdio.h>

/*
 * calcul de la valeur d'un polynme en un point x
 * grce au schma de Hrner
 *
 */
 
double horner(double x, double poly[], int degre){
	int k;
	double val;

	val = 0;
	for(k=0; k<=degre; k++)
		val = val * x + poly[k];
		
	return val;
}

int main(){
	double x, poly[] = {1, -7, 12};
	int k, d = 2;
	
	printf("Polynome P(x) =");
	for(k=0; k<=d; k++)
		printf(" %+lfx^%d", poly[k], d-k);

 	printf("\nEn quelle valeur de x le polynome doit-il etre evalue ? ");
 	scanf("%lf", &x);
 	
 	printf("P(%lf) = %lf\n", x, horner(x, poly, d));
 	
 	return 0;
	
}
